## pytorch-sparse 0.6.18

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(torchsparse)
set(CMAKE_CXX_STANDARD 14)
set(TORCHSPARSE_VERSION 0.6.18)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

option(WITH_CUDA "Enable CUDA support" OFF)
option(WITH_PYTHON "Link to Python when building" ON)
option(WITH_METIS "Enable METIS support" OFF)

if(WITH_CUDA)
  enable_language(CUDA)
  add_definitions(-D__CUDA_NO_HALF_OPERATORS__)
  add_definitions(-DWITH_CUDA)
  set(CMAKE_CUDA_FLAGS "${CMAKE_CUDA_FLAGS} --expt-relaxed-constexpr")
endif()

if (WITH_PYTHON)
  add_definitions(-DWITH_PYTHON)
  find_package(Python3 COMPONENTS Development)
endif()
find_package(Torch REQUIRED)

if (WITH_METIS)
  add_definitions(-DWITH_METIS)
  find_package(METIS)
endif()

file(GLOB HEADERS csrc/*.h)
file(GLOB OPERATOR_SOURCES csrc/*.* csrc/cpu/*.*)
if(WITH_CUDA)
  file(GLOB OPERATOR_SOURCES ${OPERATOR_SOURCES} csrc/cuda/*.h csrc/cuda/*.cu)
endif()

add_library(${PROJECT_NAME} SHARED ${OPERATOR_SOURCES})
target_link_libraries(${PROJECT_NAME} PRIVATE ${TORCH_LIBRARIES})
if (WITH_PYTHON)
  target_link_libraries(${PROJECT_NAME} PRIVATE Python3::Python)
endif()
if (WITH_METIS)
  target_include_directories(${PROJECT_NAME} PRIVATE ${METIS_INCLUDE_DIRS})
  target_link_libraries(${PROJECT_NAME} PRIVATE ${METIS_LIBRARIES})
endif()
find_package(OpenMP)
if (OPENMP_FOUND)
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
#    set (CMAKE_CUDA_FLAGS "${CMAKE_CUDA_FLAGS} -Xcompiler=${OpenMP_CXX_FLAGS}")
    set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${OpenMP_EXE_LINKER_FLAGS}")
endif()
set_target_properties(${PROJECT_NAME} PROPERTIES EXPORT_NAME TorchSparse)

target_include_directories(${PROJECT_NAME} INTERFACE
  "$<BUILD_INTERFACE:${HEADERS}>"
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

set(PHMAP_DIR third_party/parallel-hashmap)
target_include_directories(${PROJECT_NAME} PRIVATE ${PHMAP_DIR})

set(TORCHSPARSE_CMAKECONFIG_INSTALL_DIR "share/cmake/TorchSparse" CACHE STRING "install path for TorchSparseConfig.cmake")

configure_package_config_file(cmake/TorchSparseConfig.cmake.in
  "${CMAKE_CURRENT_BINARY_DIR}/TorchSparseConfig.cmake"
  INSTALL_DESTINATION ${TORCHSPARSE_CMAKECONFIG_INSTALL_DIR})

write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/TorchSparseConfigVersion.cmake
	VERSION ${TORCHSPARSE_VERSION}
  COMPATIBILITY AnyNewerVersion)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/TorchSparseConfig.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/TorchSparseConfigVersion.cmake
  DESTINATION ${TORCHSPARSE_CMAKECONFIG_INSTALL_DIR})

install(TARGETS ${PROJECT_NAME}
  EXPORT TorchSparseTargets
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  )

install(EXPORT TorchSparseTargets
  NAMESPACE TorchSparse::
  DESTINATION ${TORCHSPARSE_CMAKECONFIG_INSTALL_DIR})

install(FILES ${HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME})
install(FILES
  csrc/cpu/convert_cpu.h
  csrc/cpu/diag_cpu.h
  csrc/cpu/metis_cpu.h
  csrc/cpu/rw_cpu.h
  csrc/cpu/saint_cpu.h
  csrc/cpu/sample_cpu.h
  csrc/cpu/spmm_cpu.h
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME}/cpu)
if(WITH_CUDA)
  install(FILES
    csrc/cuda/convert_cuda.h
    csrc/cuda/diag_cuda.h
    csrc/cuda/rw_cuda.h
    csrc/cuda/spmm_cuda.h
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME}/cuda)
endif()

if(WITH_CUDA)
  set_property(TARGET torch_cuda PROPERTY INTERFACE_COMPILE_OPTIONS "")
  set_property(TARGET torch_cpu PROPERTY INTERFACE_COMPILE_OPTIONS "")
endif()

## pytorch-sparse 0.6.16

=== debian/changelog ===
pytorch-sparse (0.6.16-2) unstable; urgency=medium

  * Set upstream metadata fields: Repository.

 -- Andrius Merkys <merkys@debian.org>  Wed, 08 Mar 2023 07:12:56 -0500

pytorch-sparse (0.6.16-1) unstable; urgency=medium

  * Initial release. (Closes: #1031265)

 -- Andrius Merkys <merkys@debian.org>  Wed, 15 Feb 2023 02:07:46 -0500

=== debian/control ===
Source: pytorch-sparse
Section: science
Priority: optional
Maintainer: Debian Deep Learning Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Andrius Merkys <merkys@debian.org>,
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-python3,
 libparallel-hashmap-dev,
 libtorch-dev,
 pybind11-dev,
 python3-all,
 python3-pytest <!nocheck>,
 python3-scipy <!nocheck>,
 python3-setuptools,
 python3-torch,
 python3-torch-scatter <!nocheck>,
Testsuite: autopkgtest-pkg-pybuild
Standards-Version: 4.6.2
Homepage: https://github.com/rusty1s/pytorch_sparse
Vcs-Browser: https://salsa.debian.org/deeplearning-team/pytorch-sparse
Vcs-Git: https://salsa.debian.org/deeplearning-team/pytorch-sparse.git

Package: python3-torch-sparse
Architecture: any
Depends:
 python3-torch-scatter,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: PyTorch Extension Library of Optimized Autograd Sparse Matrix Operations
 This package consists of a small extension library of optimized sparse matrix
 operations with autograd support.
 .
 This package installs the library for Python 3.

=== debian/watch ===
version=4
https://pypi.debian.net/torch_sparse/torch_sparse-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## pytorch-sparse 0.6.18

=== debian/changelog ===
pytorch-sparse (0.6.18-3) unstable; urgency=medium

  * Team upload.
  * d/patches: backport upstream patch to replace c10::optional with
    std::optional.
  * d/control: bump std-ver to 4.7.1 (no changes required).
  * d/rules: make dh_auto_clean more robust.
  * Rebuild for libtorch2.6 transition.

 -- Shengqi Chen <harry@debian.org>  Mon, 24 Feb 2025 00:09:10 +0800

pytorch-sparse (0.6.18-2) unstable; urgency=medium

  * Build only on default Python (Closes: #1058208)

 -- Andrius Merkys <merkys@debian.org>  Thu, 14 Dec 2023 02:10:34 -0500

pytorch-sparse (0.6.18-1) unstable; urgency=medium

  * New upstream version 0.6.18

 -- Andrius Merkys <merkys@debian.org>  Mon, 09 Oct 2023 01:48:12 -0400

pytorch-sparse (0.6.17-1) unstable; urgency=medium

  * New upstream version 0.6.17
  * Watch GitHub tags.

 -- Andrius Merkys <merkys@debian.org>  Sat, 09 Sep 2023 01:24:06 -0400

=== debian/control ===
--- 
+++ 
@@ -11,14 +11,14 @@
  libparallel-hashmap-dev,
  libtorch-dev,
  pybind11-dev,
- python3-all,
+ python3,
  python3-pytest <!nocheck>,
  python3-scipy <!nocheck>,
  python3-setuptools,
  python3-torch,
  python3-torch-scatter <!nocheck>,
 Testsuite: autopkgtest-pkg-pybuild
-Standards-Version: 4.6.2
+Standards-Version: 4.7.1
 Homepage: https://github.com/rusty1s/pytorch_sparse
 Vcs-Browser: https://salsa.debian.org/deeplearning-team/pytorch-sparse
 Vcs-Git: https://salsa.debian.org/deeplearning-team/pytorch-sparse.git

=== debian/rules ===
#!/usr/bin/make -f

# See debhelper(7) (uncomment to enable).
# Output every command that modifies files on the build system.
#export DH_VERBOSE = 1

export PYBUILD_NAME = torch-sparse

%:
	dh $@ --buildsystem=pybuild

override_dh_auto_clean:
	-dh_auto_clean
	-$(RM) -rf .pybuild/

# If you need to rebuild the Sphinx documentation:
# Add sphinxdoc to the dh --with line.
#
# And uncomment the following lines.
#execute_after_dh_auto_build-indep: export http_proxy=127.0.0.1:9
#execute_after_dh_auto_build-indep: export https_proxy=127.0.0.1:9
#execute_after_dh_auto_build-indep:
#	PYTHONPATH=. python3 -m sphinx -N -bhtml \
#	docs/ build/html # HTML generator
#	PYTHONPATH=. python3 -m sphinx -N -bman \
#	docs/ build/man # Manpage generator

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?@ANY_VERSION@(@ARCHIVE_EXT@)%@PACKAGE@-$1$2%" \
 https://github.com/rusty1s/pytorch_sparse/tags \
 (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
